/*   _                                
    ( )                               
   _| |   __   _ __   ___ ___     _ _ 
 /'_` | /'__`\( '__)/' _ ` _ `\ /'_` )
( (_| |(  ___/| |   | ( ) ( ) |( (_| |
`\__,_)`\____)(_)   (_) (_) (_)`\__,_) 

*/
local PANEL = {}

AccessorFunc( PANEL, "Entity", 			"Entity" )
AccessorFunc( PANEL, "vCamPos", 		"CamPos" )
AccessorFunc( PANEL, "fFOV", 			"FOV" )
AccessorFunc( PANEL, "vLookatPos", 		"LookAt" )

/*---------------------------------------------------------
   Name: Init
---------------------------------------------------------*/
function PANEL:Init()

	self.Entity = nil
	self.LastPaint = 0
	
	self:SetCamPos( Vector( 50, 50, 50 ) )
	self:SetLookAt( Vector( 0, 0, 40 ) )
	self:SetFOV( 70 )
	
	self:SetText( "" )
	
end

function PANEL:SetModel( strModelName, strModelnameHat )

	if ( IsValid( self.Entity ) ) then
		self.Entity:Remove()
		self.Entity = nil		
	end
	
	if ( !ClientsideModel ) then return end
	
	self.Entity = ClientsideModel( strModelName, RENDER_GROUP_OPAQUE_ENTITY )
	self.Model = ClientsideModel( strModelnameHat, RENDER_GROUP_OPAQUE_ENTITY )
	if ( !IsValid(self.Entity) or !IsValid(self.Model) ) then return end
	
	self.Entity:SetNoDraw( true )	
	self.Model:SetNoDraw( true )	
end

function PANEL:GetHatEntity()
	return self.Model
end

function PANEL:SetHatColor(R,G,B,A)
	self.r = R or 255
	self.g = G or 255
	self.b = B or 255
	self.a = A or 255
end

function PANEL:Paint()
	if self.a == nil then self.a = 255 end
	if self.b == nil then self.b = 255 end
	if self.g == nil then self.g = 255 end
	if self.r == nil then self.r = 255 end
	if ( !IsValid( self.Entity ) or !IsValid( self.Model ) ) then return end
	
	local x, y = self:LocalToScreen( 0, 0 )
		
	cam.Start3D( self.vCamPos, (self.vLookatPos-self.vCamPos):Angle(), self.fFOV, x, y, self:GetWide(), self:GetTall() )
	cam.IgnoreZ( true )
	
	render.SuppressEngineLighting( true )
	render.SetLightingOrigin( self.Entity:GetPos() )
		
	self.Entity:DrawModel()
	render.SetColorModulation( self.r/255, self.g/255, self.b/255 )
	render.SetBlend( self.a/255 )
	self.Model:DrawModel()
	
	render.SuppressEngineLighting( false )
	cam.IgnoreZ( false )
	cam.End3D()
	
	self.LastPaint = RealTime()
	
end

derma.DefineControl( "DModelPanelHatMaker", "A panel containing a model", PANEL, "DButton" )